// BSAtomicEduDlg.cpp : implementation file
// Copyright (C) BrigSoft, 2002
// http://www.brigsoft.com
// Project and article are placed at http://www.brigsoft.com/bsatomic/

#include "stdafx.h"

//Add by Alex
#include "Wininet.h"

#include "BSAtomicEdu.h"
#include "BSAtomicEduDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBSAtomicEduDlg dialog

CBSAtomicEduDlg::CBSAtomicEduDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBSAtomicEduDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBSAtomicEduDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBSAtomicEduDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBSAtomicEduDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBSAtomicEduDlg, CDialog)
	//{{AFX_MSG_MAP(CBSAtomicEduDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_SYNCRO, OnSyncro)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBSAtomicEduDlg message handlers

BOOL CBSAtomicEduDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBSAtomicEduDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBSAtomicEduDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBSAtomicEduDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// LocalZoneTime function calculate Local time using Universal time.
// Time zone information is gotten from Windows using 
// GetTimeZoneInformation API function (see MSDN for mo information).
// The function support DST time.
// Created by Alex.
void LocalZoneTime(const SYSTEMTIME& tmUniversal, SYSTEMTIME& tmLocal)
{
	
	TIME_ZONE_INFORMATION TZI;
	DWORD retCode = GetTimeZoneInformation(&TZI);

	int iStandardMonth = TZI.StandardDate.wMonth;
	int iDaylightMonth = TZI.DaylightDate.wMonth;

	long nZoneCorrection = TZI.Bias;

	if( retCode ==  TIME_ZONE_ID_STANDARD){
	    nZoneCorrection = nZoneCorrection + TZI.StandardBias;
	}
	else if( retCode ==  TIME_ZONE_ID_DAYLIGHT){
		nZoneCorrection = nZoneCorrection + TZI.DaylightBias;
	}
	else{
		ASSERT(0);
	}
		
	nZoneCorrection = -nZoneCorrection;
	int nTotalMinutes  = tmUniversal.wHour * 60 + tmUniversal.wMinute + nZoneCorrection;
	if(nTotalMinutes < 0){
		nTotalMinutes+=24*60;
	}
	if(nTotalMinutes>24*60){
		nTotalMinutes-=24*60;
	}

	tmLocal.wHour	= nTotalMinutes /60;
	tmLocal.wMinute	= nTotalMinutes - tmLocal.wHour*60;
	tmLocal.wSecond = tmUniversal.wSecond;
}

// OnSyncro is called after ID_SYNCRO dialog button pressing.
// It opens Internet connection, receives Universal Time,
// calculates Local Time and set it in Windows.
// Created by Alex.
void CBSAtomicEduDlg::OnSyncro() 
{

	// Open Internet connection.
	HINTERNET hInternet = ::InternetOpen("BSAtomicEdu", INTERNET_OPEN_TYPE_PRECONFIG  , NULL, NULL, 0);//INTERNET_FLAG_ASYNC);
	if(!hInternet){
		AfxMessageBox( "Internet open error! Test your system and try again.", MB_OK | MB_ICONERROR );
		return;
	}

	// Open site of U.S. Naval Observatory. 
	unsigned long Context = 777;
	HINTERNET hHttp = ::InternetOpenUrl(hInternet, "http://tycho.usno.navy.mil/cgi-bin/timer.pl",
									  NULL, -1L, INTERNET_FLAG_RELOAD, Context);

	if(!hHttp){
		AfxMessageBox("URL open error!", MB_OK | MB_ICONERROR );

		if(hInternet){
			InternetCloseHandle(hInternet);
		}		
		return;
	}

	// Read the time from site
	CString buff(' ',1024);	
	unsigned long NumberOfBytesRead = 0;
	BOOL bRet = ::InternetReadFile(hHttp, (void *)((LPCTSTR)buff), 1024L, &NumberOfBytesRead);

	// Close Internet connection.
	if(hHttp){
		InternetCloseHandle(hHttp);
	}
	if(hInternet){
		InternetCloseHandle(hInternet);
	}

	// Is received information correct?
	if(!bRet){			
		AfxMessageBox( "URL reading error! Test internet connection  and try again.",  MB_OK | MB_ICONERROR );
		return;
	}
	if(NumberOfBytesRead != 603){
		AfxMessageBox( "Unrecognized communication error!", MB_OK | MB_ICONERROR );
		return;
	}


	// Parse Universal time from string buffer to SYSTEMTIME struct.
	SYSTEMTIME tmUniversal, tmLocal, dtOldTime;
	ZeroMemory(&tmUniversal,sizeof(tmUniversal));
	GetLocalTime(&tmLocal);
	dtOldTime = tmLocal;

	tmUniversal.wHour	= atoi((LPCTSTR)buff.Mid(111,2));
	tmUniversal.wMinute = atoi((LPCTSTR)buff.Mid(114,2));
	tmUniversal.wSecond = atoi((LPCTSTR)buff.Mid(117,2));

	// Calculate Local Time using received Universal Time.
	LocalZoneTime(tmUniversal, tmLocal);

	// Make Windows time correction.
	SetLocalTime(&tmLocal);

	// Show report dialog box.
	CString sReport;
	sReport.Format( "Successful synchronization!\n"
					"Time before: %02d:%02d:%02d.\n"
					"Time after: %02d:%02d:%02d.\n",
					dtOldTime.wHour, dtOldTime.wMinute, dtOldTime.wSecond, 
					tmLocal.wHour, tmLocal.wMinute, tmLocal.wSecond);

	AfxMessageBox( sReport, MB_OK | MB_ICONINFORMATION );

	return;	
}